package com.belkast.soap;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLSession;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.util.Base64;
import java.util.Map;

public class soapProcessor {

    public static String getCredentials(String username, String password) throws Exception
    {
        if (username == null || password == null)
        {
            return null;
        }

        String login = username + ":" + password;
        String credentials = Base64.getEncoder().encodeToString(login.getBytes());
        return credentials;
    }

    public static Boolean closeConnection(HttpURLConnection thisConn) throws Exception
    {
        thisConn.disconnect();
        return true;
    }
        public static HttpURLConnection getConnection(String thisCredentials, String thisURL, Boolean thisSSL, String thisKeystore, String thisPassword) throws Exception
    {
        URL url = new URL(thisURL);
        if (thisSSL && thisKeystore != null && thisPassword != null)
        {
            debugProcessor.writer(false, "SSL: " + thisSSL);
            debugProcessor.writer(false, "JAVA Keystore: " + thisKeystore);
            debugProcessor.writer(false, "JAVA Password: " + thisPassword);
            System.setProperty("javax.net.ssl.trustStore", thisKeystore);
            System.setProperty("javax.net.ssl.trustStorePassword", thisPassword);
        }
        try
        {
            URLConnection connection = url.openConnection();
            if (thisCredentials != null)
            {
                debugProcessor.writer(false, "Passing Username and Password to this service!");
                connection.setRequestProperty("Authorization", "Basic " + thisCredentials);
            }
            else
            {
                debugProcessor.writer(false, "This service does not require a login!");
            }
            HttpURLConnection httpConn = (HttpURLConnection)connection;
            return httpConn;
        }
        catch (Exception ex)
        {
            System.out.println(ex.toString());
            return null;
        }
    }

    public static String send(HttpURLConnection thisConn, String varInputFile, Map hashMap, byte[] document) throws Exception
    {
        StringBuilder response = new StringBuilder(500);

        try {
            ByteArrayOutputStream outstr = new ByteArrayOutputStream();
            thisConn.setRequestProperty("Content-Length", String.valueOf(document.length));
            thisConn.setRequestProperty("Content-Type", "text/xml; charset=utf-8");
            thisConn.setRequestMethod("POST");
            thisConn.setDoOutput(true);
            thisConn.setDoInput(true);

            OutputStream out = thisConn.getOutputStream();
            out.write(document);
            out.close();

            InputStreamReader ireader = new InputStreamReader(thisConn.getInputStream());

            BufferedReader in = new BufferedReader(ireader);
            String inputLine;
            while ((inputLine = in.readLine()) != null)
            {
                response.append(inputLine);
            }

            in.close();
        }
        catch (Exception ex)
        {
            System.out.println(ex.toString());
            return ex.toString();
        }

        return response.toString();
    }

    static
    {
        HttpsURLConnection.setDefaultHostnameVerifier(new HostnameVerifier()
        {
            public boolean verify(String hostname, SSLSession sslSession)
            {
                return true;
            }
        });
    }
}
