package com.belkast.soap;

import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVRecord;
import org.apache.commons.csv.DuplicateHeaderMode;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.*;

public class userVerify
{
    public static void main (String[] args) throws IOException
    {
        System.out.println();
        String varPrompt = "Please enter the name of the CSV file to validate : ";
        String varFileName;

        Scanner myObj = new Scanner(System.in);  // Create a Scanner object
        while (true)
        {
            System.out.print(varPrompt);
            varFileName = myObj.nextLine();
            File thisFile = new File(varFileName);
            Boolean isValidFile = fileProcessor.validFile(varFileName);
            if ( thisFile.exists() && isValidFile )
            {
                break;
            }
            varPrompt = "\nThe CSV file does not exist or cannot be read!\nPlease enter the name of the CSV file to validate : ";
        }

        Boolean varUserBlockEmpty = false;

        HashMap<String, Boolean> valueMap = new HashMap();
        valueMap.put("Y", true);
        valueMap.put("N", false);
        valueMap.put("", true);

        while (true)
        {
            System.out.print("Invalidate a line if there are empty column values? (Y/n) : ");
            String varAnswer = myObj.nextLine();
            String varSanitized = varAnswer.toUpperCase().trim();

            if (varSanitized.equals("Y") || varSanitized.equals("N") || varSanitized.isEmpty())
            {
                varUserBlockEmpty = valueMap.get(varSanitized);
                break;
            }
        }

        System.out.println();
        debugProcessor.writer(true, "CSV filename to validate : " + varFileName);
        debugProcessor.writer(true, "CSV invalidate on empty  : " + varUserBlockEmpty);
        debugProcessor.writer(true, "");

        ArrayList thisCSV = readCSV(varFileName, true, varUserBlockEmpty);
        debugProcessor.writer(true, "");

        Iterator<Map> mapper1 = thisCSV.iterator();
        int varIter = 0;
        while (mapper1.hasNext())
        {
            varIter++;
            Map thisMap = mapper1.next();
            Iterator<Map.Entry<Integer, Integer>> it = thisMap.entrySet().iterator();
            while (it.hasNext())
            {
                Map.Entry<Integer, Integer> pair = it.next();
                debugProcessor.writer(true, "record " + varIter + " : [" + pair.getKey() + "] => " + pair.getValue());
            }
            debugProcessor.writer(true, "");
        }
        boolean validfile = (!thisCSV.isEmpty());
        debugProcessor.writer(true, "CSV file records  : " + varIter);
        debugProcessor.writer(true, "CSV file is valid : " + validfile);
        System.out.println();
    }

        public static ArrayList readCSV (String thisFile, boolean fromUser, boolean blockEmpty)
        {
            int readNum = 0;
            int invalidNum = 0;
            ArrayList finalArray = new ArrayList();
            File varFile = new File (thisFile);
            if (!varFile.exists())
            {
                System.out.println("CSV failure error : File not found. Please enter a valid filename!");
                System.exit(0);
            }

            String exceptionReason = null;
            Boolean failedOnException = false;
            Boolean parsedCorrectly = false;
            long lineNum = 0;

            while (!parsedCorrectly && !failedOnException) {
                try (final Reader in = new InputStreamReader(new FileInputStream(varFile.getPath()), "UTF-8"))
                {
                    String varHeader = new String();
                    varHeader = fileProcessor.readFirstLine(thisFile);
                    if (varHeader.length() == 0)
                    {
                        System.out.println("CSV failure error  : Header line not found!");
                        return finalArray;
                    }

                    CSVFormat csvFormat = CSVFormat.EXCEL.builder()
                            .setHeader()
                            .setSkipHeaderRecord(false)
                            .setAllowMissingColumnNames(false)
                            .setIgnoreEmptyLines(true)
                            .setIgnoreSurroundingSpaces(true)
                            .setIgnoreHeaderCase(true)
                            .setTrim(true)
                            .setDuplicateHeaderMode(DuplicateHeaderMode.DISALLOW)
                            .build();

                    Iterable<CSVRecord> records = csvFormat.parse(in);

                    int thisHeaderLength = varHeader.split(",").length;
                    debugProcessor.writer(fromUser, "CSV header length  : " + thisHeaderLength);
                    debugProcessor.writer(fromUser, "CSV header tokens  : " + varHeader);
                    debugProcessor.writer(fromUser, "");

                    for (CSVRecord record : records)
                    {
                        readNum++;
                        lineNum = record.getParser().getCurrentLineNumber();

                        boolean isValid = record.isConsistent();
                        int thisSize = record.size();
                        String thisLine = Files.readAllLines(Paths.get(thisFile)).get(Math.toIntExact(lineNum - 1));
                        Boolean validValues = true;

                        if (isValid)
                        {
                            Map thisMap = record.toMap();
                            Iterator<Map.Entry<Integer, Integer>> it = thisMap.entrySet().iterator();
                            while (it.hasNext())
                            {
                                Map.Entry<Integer, Integer> pair = it.next();
                                String thisVal = String.valueOf(pair.getValue());
                                if (blockEmpty && (pair.getValue() == null || thisVal.isEmpty()))
                                {
                                    validValues = false;
                                    debugProcessor.writer(fromUser, "!! line " + lineNum + " [failed] : check for empty token value [" + pair.getKey() + "]");
                                }
                            }
                        }

                        Map<String, String> thisMap = record.toMap();
                        if (isValid && validValues)
                        {
                            debugProcessor.writer(fromUser, "## line " + lineNum + " [passed]");
                            finalArray.add(thisMap);
                        }
                        else
                        {
                            invalidNum++;
                            debugProcessor.writer(fromUser, "!! line " + lineNum + " [failed] : " + thisLine);
                            debugProcessor.writer(fromUser, "!! line " + lineNum + " [failed] : " + record.toMap().toString());
                            if (thisSize > thisHeaderLength )
                            {
                                debugProcessor.writer(fromUser, "!! line " + lineNum + " [failed] : too many tokens or preceding line is wonky [map size is " + thisSize + ", should be " + thisHeaderLength + "]");
                            }
                        }
                    }
                }
                catch (Exception e)
                {
                    exceptionReason = e.getMessage();
                    failedOnException = true;
                    break;
                }
                parsedCorrectly = true;
            }

                debugProcessor.writer(fromUser,"");
                debugProcessor.writer(fromUser, "CSV total lines    : " + fileProcessor.numberOfLines(thisFile));
                debugProcessor.writer(fromUser, "CSV records read   : " + String.valueOf(readNum));
                debugProcessor.writer(fromUser, "CSV records passed : " + String.valueOf(readNum - invalidNum));
                debugProcessor.writer(fromUser, "CSV records failed : " + invalidNum);

                if (exceptionReason != null)
                {
                    debugProcessor.writer(fromUser, "CSV failure error  : " + exceptionReason);
                }

            if (invalidNum > 0)
            {
                finalArray = new ArrayList();
            }

            return finalArray;
        }
}
