package com.belkast.soap;

import com.beust.jcommander.ParameterException;
import com.beust.jcommander.*;

import java.io.File;
import java.net.HttpURLConnection;
import java.text.SimpleDateFormat;
import java.util.*;

public class webService {
    static Date dateStart = new Date();
    static SimpleDateFormat varFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    static Boolean varDebug = false;
    static String varKey;
    static String varSalt = "1zcHJvdG9ubWFpbC9icmlkZ2UtdjMvdXNlcnMvYnJpZGdlLXZhdWx0LWtleQl0gx";

    public static void main(String... argv) throws Exception
    {
        System.out.println();
        // @Parameter(names = "--props",
        // description = "Location of the Properties file")

        // @Parameter(names = "--key",
        // description = "Encryption Key (length of 16)")

        // @Parameter(names = "--encrypt",
        // description = "Encrypt this value using the Key")

        // @Parameter(names = "--debug",
        // description = "Write details to the screen")

        jCommanderArgs args = new jCommanderArgs();
        JCommander jct = new JCommander(args);

        try {
            jct.parse(argv);
        } catch (ParameterException ex) {
            jct.usage();
            System.exit(0);
        }

        varDebug = args.debug;
        varKey = args.key;
        String varToEncrypt = args.encrypt;

        if (varToEncrypt != null && !varToEncrypt.isEmpty())
        {
            String varToStore = salter.encrypt(varToEncrypt, varKey, varSalt);
            String varChecked = salter.decrypt(varToStore, varKey, varSalt);

            System.out.println("Clear Text Password : " + varToEncrypt);
            System.out.println("Encryption Key      : " + varKey);
            System.out.println("Encrypted / Encoded : " + varToStore);
            System.out.println("Decoded / Decrypted : " + varChecked);
            System.out.println();
            System.exit(0);
        }

        String varProps = args.props;
        if (varProps == null && varToEncrypt == null)
        {
            debugProcessor.writer(true, "Check the program parameters. There is nothing to do!");
            System.out.println();
            jct.usage();
            System.exit(0);
        }

        if (!fileProcessor.getFile(varProps) || !fileProcessor.validFile(varProps))
        {
            debugProcessor.writer(true, "Please check that the properties file " + varProps + " is correctly formatted!");
            System.out.println();
            System.exit(0);
        }

        if (varProps != null)
        {
            doSoap(new File(varProps));
        }

        System.out.println();
        System.exit(0);

    }

    private static void doSoap(File thisProps) throws Exception {
        String varPassword = "";
        debugProcessor.writer(false, "Debug is set to : " + varDebug);

        String varURL = propertyProcessor.getProperty(thisProps, "SHIM_URL", null);
        String varKeystore_LOC = propertyProcessor.getProperty(thisProps, "JAVA_KS_LOCATION", null);
        String varInputFile = propertyProcessor.getProperty(thisProps, "XML_FILE", null);
        String varRoleFile = propertyProcessor.getProperty(thisProps, "CSV_FILE",null);
        String varKeystore_PW = propertyProcessor.getProperty(thisProps, "JAVA_KS_PASSWORD", null);

        String varPropAuthRequired = propertyProcessor.getProperty(thisProps, "AUTH_REQUIRED", "true");

        String varPropUseSSL = propertyProcessor.getProperty(thisProps, "SSL", "true");

        String varPropEmptyColumns = propertyProcessor.getProperty(thisProps, "CSV_ALLOW_EMPTY_COLUMN_VALUES", "false");

        try {
            File checkInput = new File(varInputFile);
            if (!checkInput.exists()) {
                debugProcessor.writer(true, thisProps + " => The file specified in XML_FILE does not exist [ " + varInputFile + " ]");
                System.out.println();
                System.exit(0);
            }

            if (varURL.isEmpty())
            {
                throw new RuntimeException("SHIM_URL cannot be empty");
            }

            File checkRole = new File(varRoleFile);
            if (!checkRole.exists()) {
                debugProcessor.writer(true, thisProps + " => The file specified in CSV_FILE does not exist [ " + varRoleFile + " ]");
                System.out.println();
                System.exit(0);
            }
        }
        catch (Exception e)
        {
            debugProcessor.writer(true, thisProps + " => The properties file is missing a required value!");
            debugProcessor.writer(true, thisProps + " => Required values : SHIM_URL, XML_FILE, CSV_FILE");
            System.out.println();
            System.exit(0);
        }

        Boolean varUseSSL = Boolean.valueOf(varPropUseSSL);
        Boolean varAuthRequired = Boolean.valueOf(varPropAuthRequired);
        Boolean varEmptyColumns = Boolean.valueOf(varPropEmptyColumns);

        String varUsername = propertyProcessor.getProperty(thisProps, "USERNAME", null);
        if (varAuthRequired && varUsername == null)
        {
            varUsername = userCreds.getUsername("Please enter your username : ");
        }

        String varPasswordTemp = propertyProcessor.getProperty(thisProps, "PASSWORD", null);
        if (varAuthRequired && varPasswordTemp == null)
            {
                char[] varUserPW = userCreds.getPassword("Please enter your password : ");
                varPasswordTemp = salter.encrypt(String.copyValueOf(varUserPW), varKey, varSalt);
            }

        try
            {
                varPassword = salter.decrypt(varPasswordTemp, varKey, varSalt);
            }
        catch(Exception e)
            {
                debugProcessor.writer(true, "The password could not be decrypted. Please check that the Encryption Key is correct!");
                System.out.println();
                System.exit(0);
            }

        debugProcessor.writer(varDebug, "");
        debugProcessor.writer(varDebug, thisProps + " => SOAP URL : " + (varURL == null ? "" : varURL));
        debugProcessor.writer(varDebug, thisProps + " => Authentication required : " + varAuthRequired);
        debugProcessor.writer(varDebug, thisProps + " => Use SSL : " + varUseSSL);
        debugProcessor.writer(varDebug, thisProps + " => JAVA keystore location : " + (varKeystore_LOC == null ? "" : varKeystore_LOC));
        debugProcessor.writer(varDebug, thisProps + " => JAVA keystore password : " + (varKeystore_PW == null ? "" : varKeystore_PW));
        debugProcessor.writer(varDebug, thisProps + " => XML file : " + (varInputFile == null ? "" : varInputFile));
        debugProcessor.writer(varDebug, thisProps + " => CSV file : " + (varRoleFile == null ? "" : varRoleFile));
        debugProcessor.writer(varDebug, thisProps + " => CSV allow empty : " + varEmptyColumns);

        if (!varAuthRequired)
        {
            varUsername = null;
            varPassword = null;
        }
        else
        {
            debugProcessor.writer(varDebug, thisProps + " => Username : " + varUsername);
        }

        ArrayList thisCSV = userVerify.readCSV(varRoleFile, false, !varEmptyColumns);

        boolean validfile = (!thisCSV.isEmpty());
        debugProcessor.writer(true, varRoleFile + " => CSV file is valid  : " + validfile);
        debugProcessor.writer(true, varRoleFile + " => records to process : " + thisCSV.size());

        if (!validfile)
        {
            debugProcessor.writer(true, varRoleFile + " => verification failed : please verify the file with com.belkast.soap.userVerify!");
        }
        int varCount = 0;
        Iterator<Map> mapper1 = thisCSV.iterator();
        while (mapper1.hasNext()) {
            varCount++;
            debugProcessor.writer(true, "");
            debugProcessor.writer(true, "[" + varCount + " of " + thisCSV.size() + "] : processing started");

            Map hashMap = mapper1.next();
            debugProcessor.writer(varDebug, "record " + varCount + " : " + hashMap.values().toString());

            Iterator<Map.Entry<Integer, Integer>> it = hashMap.entrySet().iterator();
            while (it.hasNext())
            {
                Map.Entry<Integer, Integer> pair = it.next();
                debugProcessor.writer(varDebug, "record " + varCount + " : " + pair.getKey() + " => " + pair.getValue());
            }

            String varDocument = fileProcessor.replaceInFile(varInputFile, hashMap);

            if (varDocument != null && !varDocument.isEmpty())
            {
                String varCredentials = soapProcessor.getCredentials(varUsername, varPassword);

                debugProcessor.writer(varDebug, "connecting to URL : " + varURL);
                HttpURLConnection varConn = soapProcessor.getConnection(varCredentials, varURL, varUseSSL, varKeystore_LOC, varKeystore_PW);
                debugProcessor.writer(true, "[" + varCount + " of " + thisCSV.size() + "] : opened connection");

                debugProcessor.writer(varDebug, "sending XML document : " + varDocument);

                String response = soapProcessor.send(varConn, varInputFile, hashMap, varDocument.getBytes());
                debugProcessor.writer(true, "[" + varCount + " of " + thisCSV.size() + "] : XML document sent");

                debugProcessor.writer(varDebug, "response received : " + response);
                if (varConn != null)
                {
                    soapProcessor.closeConnection(varConn);
                    debugProcessor.writer(true, "[" + varCount + " of " + thisCSV.size() + "] : closed connection");
                }
            }
        }
    }
}